                        Карточная игра "Тысяча"

Версия 3.0d
5 Февраля 2007 года
=============================================================================
    - Исправление ошибки, появляющейся при попытке начать сетевую игру 
      в Windows Vista
    - Исправление: запуск игры завершался аварийно, если колода с картами, 
      выбранная в игре, была удалена с диска 

Версия 3.0c
23 Декабря 2002 года
=============================================================================
    - Исправление ошибки восстановления сетевой игры, сохраненной,
      когда ожидался снос от клиента
    - Исправление: игра зависала, если на экране появлялся какой-либо запрос 
      во время "быстрой игры на прикупе"
    - Исправление: если игрок сбрасывался с бочки из-за другого игрока,
      то счетчик болтов подряд не обнулялся
    - Исправление: если игрок попал на бочку в тот момент, когда золотой
      еще играется, то зачетные три кона на бочке начинаются только
      после завершения золотого круга
    - Исправление: когда включена галочка "Болт на своей игре не считается", 
      то этот болт в таблице не показывается
    - Если нет ограничений в 120 очков на торговлю, то максимальный реальный 
      заказ отделяется от нереальных горизонтальной чертой в меню 
      быстрого выбора заказа
    - Известный баг: если игрок находится на бочке в тот момент, когда золотой
      еще играется, то болт подряд не удваивается (в версии 3.0 этот баг
      исправить невозможно)

Версия 3.0b
3 Июня 2002 года
=============================================================================
    - Исправление: при изменении размера окна изображения игроков могли
      отображаться неправильно
    - Исправление: при свернутом окне могло выдаваться неправильное
      сообщение
    - Исправление: галочка "Нельзя одновременно влезать на бочку" работала
      только при включенной галочке "Сброс с бочки, если на нее влез другой"
    - Исправление: запрет расписывать, когда игрок находится на бочке,
      не работал, если игрок на бочке сидел на прикупе
    - Исправление: если игрок на своей игре получал третий болт подряд,
      то штраф за него не брался
    - Улучшен (до некоторой степени) алгоритм торговли при включенной
      галочке "Не вычитать заказ при росписи"

Версия 3.0a
25 Марта 2002 года
=============================================================================
    - Исправлена проблема сохранения статистики и игр, возникавшая при 
      доигрывании партий в порядке, отличном от порядка их сохранения

Версия 3.0
5 Марта 2002 года
=============================================================================
    - Теперь возможно увидеть основное окно, если оно было скрыто 
      при появлении сообщения
    - От изображения рожи на прикупе могла оставаться полоса
    - На клиенте изредка могла не добавляться строка в таблице партии
    - Если игрок взял прикуп втемную, но в картах на руках есть 4 девятки
      или их сумма недостаточна, то появится запрос о пересдаче
    - Если необходимо заставить игру поменьше шуршать жестким диском,
      то в реестре HKEY_CURRENT_USER\Software\1000 надо установить
      значение FlushFileBuffers в 0

Версия 3.0 beta4
12 Февраля 2002 года
=============================================================================
    - Мог происходить преждевременный сброс с бочки
    - Иногда в договоренностях нельзя было изменить числовые поля
    - Ctrl+Tab корректно работает для переключения между закладками 
      в договоренностях

Версия 3.0 beta3
4 Февраля 2002 года
=============================================================================
    - На сервере могли не выводится рожа игрока-клиента
    - В статистике отсутствовали данные по четвертому игроку
    - При выборе фоновой картинки правильно устанавливается текущая директория
    - В диалог Настройки добавлены две кнопки для очистки путей к файлам
      с иконкой и фоновой картинкой

Версия 3.0 beta2
28 Января 2002 года
=============================================================================
    - Круг на бочке не засчитывался, если игрок расписывал, 
      и заказ при росписи не вычитался 
    - В хелп добавлено упоминание, что при включенной галочке 
      "Болт на своей игре не считается" свои игры не идут в счет болтов подряд 
    - Сетевая игра могла начаться не сначала, не с выбранными игроками и т.п. 
    - Марьяж, захваленный клиентом, мог не учитываться на сервере 
    - На клиенте кнопка Finish нажималась самостоятельно 
    - Были некоторые проблемы с обменом изображений между клиентом и сервером 
    - Игра висла при начале локальной игры сразу после окончания сетевой 
    - Золотой круг мог закончится раньше положенного из-за пересдач 

Версия 3.0 beta
21 Января 2002 года
=============================================================================
    - Игра на четверых
    - Сетевая игра может быть сохранена для последующего доигрывания
    - Новые договоренности:
        - Прыжки в торговле запрещены
        - Болт на золотом считается за два
        - Болт на своей игре не считается
        - Можно расписывать при игре втемную
        - Для игры втемную надо иметь не менее nnn очков
        - Можно темнить, если кто-то на бочке
        - Добавлять стоимость марьяжа в прикупе
        - Добавлять стоимость половинки марьяжа в прикупе
        - Отрицательный самосвал
    - Можно задавать количество очков бочки (880 или 900) и сумму штрафа
    - Если клиент случайно отключился от сервера, то он может опять 
      подключиться к нему и продолжить игру (было реализовано еще в 2.2,
      но нигде не описано); подробности см. в хелпе Описание игры | Розыгрыш.
    - Можно настроить интервал, в течении которого компьютер ждет нажатия
      кнопки мыши, после чего продолжает игру
    - При наведении курсора мыши на ячейки в таблице партии выводятся
      подсказки с объяснением ситуации
    - Возможность прятать игру в трей по клавише Escape
    - Возможность задавать фоновую картинку
    - Исправление ситуации, когда компьютер снова и снова требовал сноса карт
      и не хотел продолжать игру.

Версия 2.2g
19 Сентября 2001 года
=============================================================================
    - Наконец-то Симпсоны нарисованы такими, какие они есть в реальной жизни. 
    - Качество элементов игрового поля и изображений Симпсонов не ухудшается
      при игре с большими разрешениями экрана. 
    - Есть возможность изменять цвет игрового поля. 
    - Есть возможность задавать фоновую картинку - пока только в реестре
      HKEY_CURRENT_USER\Software\1000 строка Background - путь к BMP-файлу. 
    - Можно использовать колоды с картами любых размеров для улучшения
      качества изображения при игре с большими разрешениями экрана. 
    - Поддержка белорусского языка (выбирается через флаг в вправом нижнем углу)
    - Теперь нельзя запускать второй экземпляр игры для того,
      чтобы подсмотреть розданные карты. 
    - Для игры можно использовать клавиатуру.
      Назначения клавиш см. в файле помощи. 
    - При выходе из игры не запрашивается подтверждение для несетевой игры. 
    - Если в тот момент, когда показывается сообщение "Игра окончена",
      закрыть игру, то партия не будет отложена, а нормально завершится.
    - В диалоге промотра последней взятки можно посмотреть все предыдущие
      взятки текущей раздачи. Эти данные сохраняются и при доигрывании
      отложенной раздачи.
    - По умолчанию при нажатии на клавишу Escape игра сворачивается в трей.
      Отменить это можно пока только через реестр:
      в HKEY_CURRENT_USER\Software\1000 установить значение HideToTray в ноль.
    - При нажатии на клавишу Escape иконка игры будет заменена на
      изображение письма, если попытка загрузить иконку из указанного
      в диалоге Настройки файла окажется неудачной. 
    - Исправление, касающееся пересдачи из-за 4-х девяток. 
    - Исправление: раньше во время сетевой игры, после растемнения
      темной другим игроком, карты оставались скрытыми.
    - Исправление: при сбросе с бочки счетчик болтов за игру
      не будет сбрасываться. 
    - Исправление, касающееся проблемы работы с файлом результатов 1000.tbl
      на некоторых Windows98. 
    - Исправление: иконка игры будет корректно заменяться не только на NT/2000,
      но и на 95/98. 

Версия 2.2f
18 Июня 2001 года
=============================================================================
    - Исправление: во время сетевой игры запрашивалась пересдача
      при скрытых картах
    - Теперь иконка игры должна меняться даже при запущеном WindowBlinds

Версия 2.2e
09 Июня 2001 года
=============================================================================
    - Исправление: во время сетевой игры неправильно обрабатывалась
      игра втемную

Версия 2.2d
31 Мая 2001 года
=============================================================================
    - Исправление: компьютер не будет заявлять о пересдаче из-за 4-х девяток
      после сноса, если все они были получены с раздачи
    - Компьютер теперь тоже может объявлять игру втемную 

Версия 2.2c
30 Мая 2001 года
=============================================================================
    - Исправление: во время сетевой игры при игре втемную очки
      могли не удваиваться

Версия 2.2b
22 Мая 2001 года
=============================================================================
    - Исправление: при установленном пункте "Не показывать прикуп при 100"
      можно было подсмотреть прикуп в окне Просмотр последней взятки/прикупа
    - Сделан предварительный просмотр изображений игроков при открытии файла

Версия 2.2a
11 Мая 2001 года
=============================================================================
    - Исправления:
        - Зависание клиента, когда его изображение бралось из файла
        - Опечатка "Теть" вместо "Тень"
        - Компьютер не замечал установки "Прятать прикуп при темной"
        - Не снималась галочка "Можно увеличивать заказ на золотом"
        - Компьютер заказывал свыше 125 на бочке, когда этого нельзя
        - Ошибка при откладывании партии после отказа от игры втемную
        - Ошибочный вывод "0" в легенде при отключенном параметре
          "Сброс на ноль после 3-х бочек"
    - При переименовании компьютерного игрока, производится также
      переименование игроков в отложенных партиях

Версия 2.2
27 Апреля 2001 года
=============================================================================
    - Новые договоренности:
        - Нельзя ходить с чужих козырей
        - Округлять очки при своей игре
        - Не показывать прикуп на 100
        - Пересдача при 4 девятках на руках (после сноса)
        - Можно расписывать, если кто-то на бочке
        - Можно расписывать при золотом
        - Можно увеличивать заказ на золотом
        - Разрешить игру втемную
        - Не показывать прикуп при темной
    - Все договоренности распределены по нескольким закладкам
    - Переделана система обозначений в таблице
    - Таблица со счетом игры может прокручиваться
    - Появился диалог с настройками интерфейса игры
        - надпись и иконка при прятании игры по Escape
        - вывод подтверждений:
          - при кидании половинки марьяжа в момент, когда нельзя объявлять козырь
          - при игре втемную
          - при начале игры без изменения заказа
          - на бочке при недостаточном заказе для выигрыша партии
        - показывать флаг
        - показывать расшифровку в таблице
        - показывать кнопку повтора
        - показывать кнопку Пас (в тех случаях, когда игрок должен спасовать:
          чтобы по отсутствии паузы другие игроки не догадались о картах)
        - цвет почти для всех объектов на игровом поле (кроме самого поля - пока)
    - Можно создавать и удалять компьютерных игроков,
      менять их стиль игры (скорее всего, в сторону ослабления)
    - Для игроков (компьютерных и человеческих) можно задавать любое изображение
    - В меню появились пункты Отложить игру и Бросить партию со штрафом
    - После окончания раздачи можно посмотреть ее повтор
    - Просмотр прикупа/последней взятки - в меню Просмотр
    - Увеличен размер сообщений чата
    - Изменен рейтинг
    - Окно игры восстанавливается перед выдачей сообщения,
      если оно было минимизировано
    - Игроков можно переименовывать
    - При просмотре договоренностей галочки черные (но менять их все равно нельзя)
    - Исправление: Компьютер не будет заказывать свыше 125 на бочке,
      когда этого нельзя
    - Исправление: Окно чата больше не будет пропадать
    - Исправление: Курсор не будет больше становиться не стрелкой
    - Исправление: Номер порта для сетевой игры берется из реестра
    - Исправление: При нажатии клиентом Cancel до начала игры
      он корректно отключается от сервера
    - Игра стала FreeWare
    - Поддержка эстонского языка
    - Кнопки на игровом поле немного отодвинуты друг от друга

Версия 2.1j
12 Мая 2000 года
=============================================================================
    - При игре с компьютером можно выходить в любой момент -
      текущее состояние расклада будет запомнено полностью. 
    - Возможность изменять размеры окна. Карты и содержимое
      увеличивается при увеличении размеров окна,
      но только в 1.5, 2, 2.5 и т.д. раза. 
    - Запоминается последняя позиция и размеры окна. 
    - Изменяется и сохраняется размер и положение окна чата. 
    - Запоминается имя игрока, который последний раз играл в игру. 
    - Запоминаются игроки справа и слева, с которыми последний раз велась игра. 
    - Поддержка французского, литовского, украинского языков, транслита. 
    - Язык можно выбрать с помощью флажка внизу экрана. 
    - Возможность выбора колоды для игры. 
    - Появилась кнопочка "..." для быстрого выбор суммы заказа из списка. 
    - Для возврата карты из сноса обратно на руку теперь
      достаточно один раз на нее щелкнуть. 
    - Щелчок мыши на окне при переключении из другого приложения не считается,
      и карты не улетают, пока на них еще не успели посмотреть. 
    - При появлении кнопки "Все мое" открываются карты у всех игроков. 
    - Двойной щелчок мышью на изображении игрока действует как кнопка "Проснись". 
    - Появился сетевой статус игрока - цветок в углу экрана и возле изображения. 
    - Кнопка "Расписать" недоступна, когда нет штрафа за роспись,
      и кто-нибудь находится на бочке или идет Золотой кон. 
    - Изменилась формула рейтинга. 
    - Исправление: если сносится часть марьяжа (или весь),
      то максимальное число очков уменьшается на сумму этого марьяжа. 
    - Исправление: раньше компьютер иногда не сносил две карты соперникам. 
    - Исправление: раньше на некоторых компьютерах с корректно настроенной
      сетью программа не находила ни одного протокола.
      Эту проблему помогли решить Евгений Денисов и Константин Оттен. 

Версия 2.1i
9 Февраля 2000 года
=============================================================================
    - Исправлены разнообразные ошибки версий 2.0 и 2.1
    - Создана справочная система   
    - Появилась поддержка немецкого языка
  
Версия 2.1
6 Декабря 1999 года
=============================================================================
    - Поддержка английского языка
    - Звуковое сопровождение
    - Переговоры друг с другом во время сетевой игры
    - Более аккуратная работа со шрифтами
    - Возможность запретить одновременное попадание на бочку
    - Возможность установить, что для победы надо набрать больше 1000 очков
    - Золотой круг
    - Тузовый марьяж
    - Возможность объявлять козырь с первого хода
    - Возможность не вычитать заказ при росписи
    - Штраф при третьей росписи
    - Торг более 120 без марьяжа
    - Отслеживание небитки
    - Исправлена ошибка в ограничении в торговле: 120+сумма марьяжей на руках
    - Исправлен баг с пересдачей при сетевой игре
    - Исправлен баг, связанный с недозаказом со стороны компьютера
    - Исправлен баг с неожиданным штрафом
    - На экран выводится имя игрока, который объявил козырь
    - Нажав клавишу Shift можно подавить объявление козыря
    - При нажатии на клавишу F9 ход текущей игры выводится в файл 1000.log
    - Сохраняются протокол и имя сервера, выбранные во время предыдущей игры

Версия 2.0
22 Ноября 1999 года
=============================================================================
    - Игра по сети
    - Роспись
    - Накопление статистики по сыгранным партиям
    - Сброс до нуля при 555 очках
    - Снос карт втемную
    - Пересдача при двух девятках в прикупе
    - Сброс с бочки, если на нее садится другой игрок
    - Возможность пересдачи не только при 100 очках
    - Возможность изменять большинство числовых параметров в договоренностях
    - Отсутствие штрафа при выходе
    - Возможность не задавать пароль
    - Возможность изменения пароля
    - Просмотр статистики и договоренностей во время игры

Версия 1.20
Август 1997 года
=============================================================================
    - Самая первая версия игры
